clear all;
close all;
clc;
org=im2double(imread('barb.gif'));
w=im2double(imread('cameraman.tif'));   
figure,imshow(org)
title('Input Image')
[sa, uw, vw, wmkd]=watermkg(org,w);
figure,imshow(wmkd);
title('Watermarked Image')
%%% Potential Attacks

prompt = {'1. Gaussian Noise, 2. Gaussian Filtering 3*3, 3. Gaussian Filtering 5*5, 4.  Gaussian Filtering 7*7, 5. Histogram Equalization, 6. JPEG Compression 75%, 7. JPEG Compression 50%, 8. Image Resizing 512->256, 9. Image Resizing 512->1024, 10. Unsharp Filtering, 11. Contrast Stretching 0.8, 12. Contrast Stretching 0.6, 13. Adding salt & pepper noise 1%, 14. Adding salt & pepper noise 5%, 15. Pixelate with 2x2 tiles, 16. Image Flipping, 17. Image Rptation 45%, 18. Pixelate with 4x4 tiles, 19. No Attack'};
dlgtitle = 'Image Potential Attack Selection';
definput = {'19'};
dims = [1 19];

answer = inputdlg(prompt,dlgtitle,dims,definput);

kk=str2num(answer{1});
switch kk
   case 1
       %# Gaussian Noise with varience 0.001
       atkd = imnoise(wmkd,'gaussian',0,0.001) ;
   case 2
        G = fspecial('gaussian',[3 3]);
        %# Gaussian Filtering 3*3
        atkd = imfilter(wmkd,G,'same');
   case 3
      G = fspecial('gaussian',[5 5]);
        %# Gaussian Filtering 5*5
        atkd = imfilter(wmkd,G,'same');
   case 4
      G = fspecial('gaussian',[7 7]);
        %# Gaussian Filtering 7*7
        atkd = imfilter(wmkd,G,'same');
    case 5
        %# Histogram Equalization
      atkd = histeq(real(wmkd)) ;
    case 6
        %# JPEG Compression 75%
        imwrite(wmkd,'man_25.jpg','Quality',75);
        
        atkd=im2double(imread('man_25.jpg'));
        atkd= rot90(atkd,2);
        figure,imshow(atkd);
    case 7
        %# JPEG Compression 50%
        imwrite(wmkd,'man_25.jpg','Quality',50);
        atkd=im2double(imread('man_25.jpg'));
        atkd= rot90(atkd,2);
        figure,imshow(atkd);
    case 8
        %# Image Resizing
        atkd = imresize(wmkd,[m/2,n/2]);
        atkd = imresize(atkd,[m,n]);
    case 9
        %# Image Resizing
        atkd = imresize(wmkd,[m*2,n*2]);
        atkd = imresize(atkd,[m,n]);
    case 10
        %# Unsharp Filtering
        H = fspecial('unsharp');
        atkd = imfilter(wmkd,H,'replicate');
    case 11
        %# Contrast Stretching 0.8
        atkd= imadjust(real(wmkd),[],[],0.8);
    case 12
        %# Contrast Stretching 0.6
        atkd= imadjust(real(wmkd),[],[],0.6);   
    case 13
        %# Adding salt & pepper noise 1%
        atkd = imnoise(wmkd,'salt & pepper',0.01);
    case 14
        %# Adding salt & pepper noise 5%
        atkd = imnoise(wmkd,'salt & pepper',0.05);
    case 15
        %# Pixelate with 2x2 tiles
        fun = inline('mean(x(:))*ones(size(x))');
        atkd = blkproc(wmkd,[2 2],fun);
    case 16
        %# Image Flipping
        atkd(1:m,1:n)=wmkd(1:m,n:-1:1);
       
    case 17
        %# Image Rptation 45%
        atkd=imresize(imrotate(real(wmkd),45),[m n]);
    case 18
        %# Pixelate with 4x4 tiles
         fun = inline('mean(x(:))*ones(size(x))');
        atkd = blkproc(wmkd,[4 4],fun);
    otherwise
        %  No Attack         
        atkd = wmkd;
end

figure,imshow(atkd);
title('Watermarked Image after Potential Attack')
%%%% Watermark Extraction
wmk=extract(uw,sa,vw,atkd);
%%%% Displying extracted Copies of watermarks 
for i=1:4
    
figure,imshow(wmk(:,:,i));
Freq={'LL','LH', 'HL', 'HH'}
title(['Extracted watermark from ',Freq{1,i},' band of Watermarked Image'])
end